import AbstractView from "../AbstractView.js";
import { client } from "../../index.js";

async function login()
{
	let username = document.getElementById("username").value;
	let password = document.getElementById("password").value;
	
	let response = await client.login(username, password);
	let response_data = await response.json();
	
	["username", "user", "password"].forEach(error_field => {
		let error_display = document.getElementById(`error_${error_field}`);
		if (error_display != null)
			error_display.innerHTML = "";
	});

	Object.keys(response_data).forEach(error_field => {
		let error_display = document.getElementById(`error_${error_field}`);
		if (error_display != null)
			error_display.innerHTML = response_data[error_field];
	});
}

export default class extends AbstractView {
    constructor(params) {
        super(params);
        this.setTitle("Login");
		document.body.addEventListener("click", e => {
			e.preventDefault();
			if (e.target.type == "button")
				login();
		});
	}

    async getHtml() {
        return `
			<div class=form>
				<label>Login</label>
				<link rel="stylesheet" href="static/css/accounts/login.css">
				<input type="text" id="username" placeholder="username">
				<span id="error_username"></span>
				<input type="password" id="password" placeholder="password">
				<span id="error_password"></span>
				<input type="button" value="login">
				<span id="error_user"></span>
				<a href="/register" class="nav__link" data-link>Register</a>
			</div>
        `;
    }
}